!--------------------------------------------------------------------------------!
!                                                                                !
! MSExcelClass                                                                   !
!                                                                                !
! Microsoft Excel Class                                                          !
!                                                                                !
! Copyright 1999 - SoftMasters (www.softmasters.com.ar)                         !
!                   Juan Domingo Herrera                                         !
!                   Matas Alejandro Flores                                      !
!                   Buenos Aires, Argentina                                      !
!                                                                                !
! Version: 2.0                                                                   !
!                                                                                !
!--------------------------------------------------------------------------------!

    MEMBER()

    INCLUDE('ABEXCEL.INC'),ONCE

    MAP
      QuoteOT(STRING Text),STRING
    END!MAP

!==============================================================================
MSExcelClass.ActivateFilter       PROCEDURE()
  CODE
    SELF.SendCommand('Selection.AutoFilter')

!==============================================================================
MSExcelClass.ActivateFilter       PROCEDURE(STRING Range)
  CODE
    SELF.SendCommand('Range("' & Range & '").AutoFilter')

!==============================================================================
MSExcelClass.AddSheet             PROCEDURE(BYTE Count=1)
  CODE
    LOOP A# = 1 TO Count
      SELF.SendCommand('Sheets.Add')
    END!LOOP

!==============================================================================
MSExcelClass.Assign               PROCEDURE(STRING Contents)
  CODE
    SELF.SetProperty('ActiveCell.FormulaR1C1',Contents)

!==============================================================================
MSExcelClass.Assign               PROCEDURE(STRING Range,STRING Contents)
  CODE
    SELF.Select(Range)
    SELF.Assign(Contents)

!==============================================================================
MSExcelClass.Assign               PROCEDURE(LONG Row,LONG Column,STRING Contents)
  CODE
    SELF.Select(Row,Column)
    SELF.Assign(Contents)

!==============================================================================
MSExcelClass.AssignWithFormat     PROCEDURE(STRING Contents,STRING Format)
  CODE
    SELF.Assign(Contents)
    SELF.SetNumberFormat(Format)

!==============================================================================
MSExcelClass.AssignWithFormat     PROCEDURE(STRING Range,STRING Contents,STRING Format)
  CODE
    SELF.Assign(Range,Contents)
    SELF.SetNumberFormat(Format)

!==============================================================================
MSExcelClass.AssignWithFormat     PROCEDURE(LONG Row,LONG Column,STRING Contents,STRING Format)
  CODE
    SELF.Assign(Row,Column,Contents)
    SELF.SetNumberFormat(Format)

!==============================================================================
MSExcelClass.AutoFitColumn        PROCEDURE()
  CODE
    SELF.SendCommand('Selection.Columns.AutoFit')

!==============================================================================
MSExcelClass.AutoFitColumn        PROCEDURE(STRING Column)
  CODE
    SELF.SendCommand('Columns("' & Column & '").AutoFit')

!==============================================================================
MSExcelClass.AutoFitColumnByNumber PROCEDURE(LONG Column)
  CODE
    SELF.SendCommand('Columns(' & Column & ').AutoFit')

!==============================================================================
MSExcelClass.AutoFitRow           PROCEDURE()
  CODE
    SELF.SendCommand('Selection.Rows.AutoFit')

!==============================================================================
MSExcelClass.AutoFitRow           PROCEDURE(LONG Row)
  CODE
    SELF.SendCommand('Rows(' & Row & ').AutoFit')

!==============================================================================
MSExcelClass.AutoFormat           PROCEDURE(BYTE Format)
  CODE
    SELF.SendCommand('Selection.AutoFormat(' & Format & ',1,1,1,1,1,1)')

!==============================================================================
MSExcelClass.AutoFormat           PROCEDURE(STRING Range,BYTE Format)
  CODE
    SELF.Select(Range)
    SELF.AutoFormat(Format)

!==============================================================================
MSExcelClass.Close                PROCEDURE(BYTE SaveChanges)
  CODE
    SELF.SendCommand('ActiveWindow.Close(' & SaveChanges & ')')

!==============================================================================
MSExcelClass.CreateFile           PROCEDURE()
  CODE
    SELF.SendCommand('Workbooks.Add')

!==============================================================================
MSExcelClass.CreateFile           PROCEDURE(STRING FileName)
  CODE
    SELF.SendCommand('Workbooks.Add("' & FileName & '")')

!==============================================================================
MSExcelClass.DataLabels           PROCEDURE(Label)
  CODE
    SELF.SendCommand('ActiveChart.ApplyDataLabels(' & Label & ')')

!==============================================================================
MSExcelClass.DataSource           PROCEDURE(BYTE Show)
  CODE
    IF Show
      SELF.SetProperty('ActiveChart.HasDataTable',True)
      SELF.SetProperty('ActiveChart.DataTable.ShowLegendKey',True)
    ELSE
      SELF.SetProperty('ActiveChart.HasDataTable',False)
      SELF.SetProperty('ActiveChart.DataTable.ShowLegendKey',False)
    END!IF

!==============================================================================
MSExcelClass.ExecFunction         PROCEDURE(STRING Contents)
  CODE
    SETCLIPBOARD(Contents)
    SELF.SendCommand('ActiveSheet.Paste')
    SETCLIPBOARD('')

!==============================================================================
MSExcelClass.ExecFunction         PROCEDURE(STRING Range,STRING Contents)
  CODE
    SELF.Select(Range)
    SELF.ExecFunction(Contents)

!==============================================================================
MSExcelClass.ExecFunction         PROCEDURE(LONG Row,LONG Column,STRING Contents)
  CODE
    SELF.Select(Row,Column)
    SELF.ExecFunction(Contents)

!==============================================================================
MSExcelClass.GetAlignment         PROCEDURE()
  CODE
    RETURN SELF.GetHAlignment()

!==============================================================================
MSExcelClass.GetAlignment         PROCEDURE(STRING Cell)
  CODE
    RETURN SELF.GetHAlignment(Cell)

!==============================================================================
MSExcelClass.GetAlignment         PROCEDURE(LONG Row,LONG Column)
  CODE
    RETURN SELF.GetHAlignment(Row,Column)

!==============================================================================
MSExcelClass.GetColumnWidth       PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Columns.ColumnWidth')

!==============================================================================
MSExcelClass.GetColumnWidth       PROCEDURE(STRING Column)
  CODE
    RETURN SELF.GetProperty('Columns("' & Column & '").ColumnWidth')

!==============================================================================
MSExcelClass.GetColumnWidthByNumber PROCEDURE(LONG Column)
  CODE
    RETURN SELF.GetProperty('Columns(' & Column & ').ColumnWidth')

!==============================================================================
MSExcelClass.GetHAlignment        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.HorizontalAlignment')

!==============================================================================
MSExcelClass.GetHAlignment        PROCEDURE(STRING Cell)
  CODE
    RETURN SELF.GetProperty('Range("' & Cell & '").HorizontalAlignment')

!==============================================================================
MSExcelClass.GetHAlignment        PROCEDURE(LONG Row,LONG Column)
  CODE
    RETURN SELF.GetProperty('Cells(' & Row & ',' & Column & ').HorizontalAlignment')

!==============================================================================
MSExcelClass.GetRegionalSetting   PROCEDURE(SHORT Setting)
  CODE
    RETURN SELF.GetProperty('Application.International(' & Setting & ')')

!==============================================================================
MSExcelClass.GetRowHeight         PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Rows.RowHeight')

!==============================================================================
MSExcelClass.GetRowHeight         PROCEDURE(LONG Row)
  CODE
    RETURN SELF.GetProperty('Rows(' & Row & ').RowHeight')

!==============================================================================
MSExcelClass.GetSeriesCount       PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveChart.SeriesCollection.Count')

!==============================================================================
MSExcelClass.GetSheetCount        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Sheets.Count')

!==============================================================================
MSExcelClass.GetSheetIndex        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveSheet.Index')

!==============================================================================
MSExcelClass.GetSheetIndex        PROCEDURE(STRING Name)
  CODE
    RETURN SELF.GetProperty('Sheets("' & Name & '").Index')

!==============================================================================
MSExcelClass.GetSheetName         PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveSheet.Name')

!==============================================================================
MSExcelClass.GetSheetName         PROCEDURE(LONG Sheet)
  CODE
    RETURN SELF.GetProperty('Sheets(' & Sheet & ').Name')

!==============================================================================
MSExcelClass.GetVAlignment        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.VerticalAlignment')

!==============================================================================
MSExcelClass.GetVAlignment        PROCEDURE(STRING Cell)
  CODE
    RETURN SELF.GetProperty('Range("' & Cell & '").VerticalAlignment')

!==============================================================================
MSExcelClass.GetVAlignment        PROCEDURE(LONG Row,LONG Column)
  CODE
    RETURN SELF.GetProperty('Cells(' & Row & ',' & Column & ').VerticalAlignment')

!==============================================================================
MSExcelClass.GetWrapText          PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.WrapText')

!==============================================================================
MSExcelClass.GetWrapText          PROCEDURE(STRING Cell)
  CODE
    RETURN SELF.GetProperty('Range("' & Cell & '").WrapText')

!==============================================================================
MSExcelClass.GetWrapText          PROCEDURE(LONG Row,LONG Column)
  CODE
    RETURN SELF.GetProperty('Cells(' & Row & ',' & Column & ').WrapText')

!==============================================================================
MSExcelClass.Graph                PROCEDURE(SHORT GraphType,BYTE Location,STRING Sheet)
  CODE
    SELF.SendCommand('Charts.Add')
    SELF.SetProperty('ActiveChart.ChartType',GraphType)
    SELF.SendCommand('ActiveChart.Location(' & Location & ', "' & Sheet & '")')

!==============================================================================
MSExcelClass.GraphBackground      PROCEDURE(SHORT Color,SHORT Width,SHORT Style,SHORT Background,SHORT BgColor,SHORT Format)
  CODE
    SELF.SendCommand('ActiveChart.PlotArea.Select')
    SELF.SetProperty('Selection.Border.ColorIndex',Color)
    SELF.SetProperty('Selection.Border.Weight',Width)
    SELF.SetProperty('Selection.Border.LineStyle',Style)
    SELF.SetProperty('Selection.Interior.ColorIndex',Background)
    SELF.SetProperty('Selection.Border.PatternColorIndex',BgColor)
    SELF.SetProperty('Selection.Border.Pattern',Format)

!==============================================================================
MSExcelClass.GraphFrame           PROCEDURE(SHORT Color,SHORT Width,SHORT Style,SHORT Background,SHORT BgColor,SHORT Format)
  CODE
    SELF.SendCommand('ActiveChart.ChartArea.Select')
    SELF.SetProperty('Selection.Border.ColorIndex',Color)
    SELF.SetProperty('Selection.Border.Weight',Width)
    SELF.SetProperty('Selection.Border.LineStyle',Style)
    SELF.SetProperty('Selection.Interior.ColorIndex',Background)
    SELF.SetProperty('Selection.Border.PatternColorIndex',BgColor)
    SELF.SetProperty('Selection.Border.Pattern',Format)

!==============================================================================
MSExcelClass.HeaderFooter         PROCEDURE(STRING LeftHeader,STRING CenterHeader,STRING RightHeader,|
                                            STRING LeftFooter,STRING CenterFooter,STRING RightFooter)
  CODE
    SELF.SetProperty('ActiveSheet.PageSetup.LeftHeader',LeftHeader)
    SELF.SetProperty('ActiveSheet.PageSetup.CenterHeader',CenterHeader)
    SELF.SetProperty('ActiveSheet.PageSetup.RightHeader',RightHeader)
    SELF.SetProperty('ActiveSheet.PageSetup.LeftFooter',LeftFooter)
    SELF.SetProperty('ActiveSheet.PageSetup.CenterFooter',CenterFooter)
    SELF.SetProperty('ActiveSheet.PageSetup.RightFooter',RightFooter)

!==============================================================================
MSExcelClass.InsertColumn         PROCEDURE(STRING Column)
  CODE
    SELF.SelectColumn(Column)
    SELF.SendCommand('Selection.Insert(' & xlToRight & ')')

!==============================================================================
MSExcelClass.InsertColumnByNumber PROCEDURE(LONG Column)
  CODE
    SELF.SelectColumnByNumber(Column)
    SELF.SendCommand('Selection.Insert(' & xlToRight & ')')

!==============================================================================
MSExcelClass.InsertRow            PROCEDURE(LONG Row)
  CODE
    SELF.SelectRow(Row)
    SELF.SendCommand('Selection.Insert(' & xlDown & ')')

!==============================================================================
MSExcelClass.LocateLegend         PROCEDURE(SHORT Where)
  CODE
    SELF.SendCommand('ActiveChart.Legend.Select')
    SELF.SetProperty('Selection.Position',Where)

!==============================================================================
MSExcelClass.LocateSerie          PROCEDURE(SHORT Serie,SHORT Where)
  CODE
    SELF.SetProperty('ActiveChart.SeriesCollection(' & Serie & ').AxisGroup',Where)

!==============================================================================
MSExcelClass.MergeCells           PROCEDURE()
  CODE
    SELF.SetMergeCells(True)

!==============================================================================
MSExcelClass.MergeCells           PROCEDURE(STRING Range)
  CODE
    SELF.SetProperty('Range("' & Range & '").MergeCells',True)

!==============================================================================
MSExcelClass.OpenFile             PROCEDURE(STRING FileName)
  CODE
    IF FileName
      SELF.SendCommand('Workbooks.Open("' & FileName & '")')
    ELSE
      SELF.CreateFile()
    END!IF

!==============================================================================
MSExcelClass.OpenFile             PROCEDURE(STRING FileName,STRING Password)
  CODE
    IF FileName
      SELF.SendCommand('Workbooks.Open("' & FileName & '",,,,"' & Password & '")')
    ELSE
      SELF.CreateFile()
    END!IF

!==============================================================================
MSExcelClass.PageSetup            PROCEDURE(BYTE PaperSize,BYTE Orientation)
  CODE
    SELF.SetProperty('Application.ActiveDocument.PageSetup.PaperSize',PaperSize)
    SELF.SetProperty('Application.ActiveDocument.PageSetup.Orientation',Orientation)

!==============================================================================
MSExcelClass.PrintDoc             PROCEDURE(BYTE Copies)
  CODE
    SELF.SendCommand('ActiveSheet.PrintOut(,,' & Copies & ',,,,,)')

!==============================================================================
MSExcelClass.Read                 PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveCell.Value')

!==============================================================================
MSExcelClass.Read                 PROCEDURE(STRING Cell)
  CODE
    SELF.Select(Cell)
    RETURN SELF.Read()

!==============================================================================
MSExcelClass.Read                 PROCEDURE(LONG Row,LONG Column)
  CODE
    SELF.Select(Row,Column)
    RETURN SELF.Read()

!==============================================================================
MSExcelClass.Replace              PROCEDURE(STRING Search,STRING Replace,BYTE MatchCase,BYTE Name)
  CODE
    IF Name = 1
      SELF.SendCommand('Application.Goto("' & Search & '")')
      SELF.Assign(Replace)
    ELSE
      SELF.SendCommand('Cells.Replace("' & Search & '","' & Replace & '",1,1,' & MatchCase & ')')
    END!IF

!==============================================================================
MSExcelClass.Save                 PROCEDURE(STRING FileName)
  CODE
    SELF.SendCommand('ActiveWorkbook.SaveAs("' & FileName & '")')

!==============================================================================
MSExcelClass.Save                 PROCEDURE(STRING FileName,LONG Format,STRING Password,STRING ReadOnlyPassword,BYTE RecommendReadOnly)
  CODE
    SELF.SendCommand('Application.ActiveWorkbook.SaveAs("' & FileName & '",' & Format & ',' & Password & ',1,' & ReadOnlyPassword & ',' & RecommendReadOnly & ',1)')

!==============================================================================
MSExcelClass.Select               PROCEDURE(STRING Range)
  CODE
    SELF.Object = SELF.GetProperty('Range("' & Range & '").Select')

!==============================================================================
MSExcelClass.Select               PROCEDURE(LONG Row,LONG Column)
  CODE
    SELF.Object = SELF.GetProperty('Cells(' & Row & ',' & Column & ').Select')

!==============================================================================
MSExcelClass.SelectColumn         PROCEDURE(STRING Column)
  CODE
    SELF.Object = SELF.GetProperty('Columns("' & Column & '").Select')

!==============================================================================
MSExcelClass.SelectColumnByNumber PROCEDURE(LONG Column)
  CODE
    SELF.Object = SELF.GetProperty('Columns(' & Column & ').Select')

!==============================================================================
MSExcelClass.SelectRow            PROCEDURE(LONG Row)
  CODE
    SELF.Object = SELF.GetProperty('Rows(' & Row & ').Select')

!==============================================================================
MSExcelClass.SelectSheet          PROCEDURE(SHORT Sheet)
  CODE
    SELF.SendCommand('Sheets(' & Sheet & ').Select')

!==============================================================================
MSExcelClass.SelectSheetByName    PROCEDURE(STRING Sheet)
  CODE
    SELF.SendCommand('Sheets("' & Sheet & '").Select')

!==============================================================================
MSExcelClass.SetAlignment         PROCEDURE(BYTE Alignment)
  CODE
    SELF.SetHAlignment(Alignment)

!==============================================================================
MSExcelClass.SetAlignment         PROCEDURE(STRING Range,BYTE Alignment)
  CODE
    SELF.SetHAlignment(Range,Alignment)

!==============================================================================
MSExcelClass.SetAlignment         PROCEDURE(LONG Row,LONG Column,BYTE Alignment)
  CODE
    SELF.SetHAlignment(Row,Column,Alignment)

!==============================================================================
MSExcelClass.SetColumnWidth       PROCEDURE(LONG Width)
  CODE
    SELF.SetProperty('Selection.Columns.ColumnWidth',Width)

!==============================================================================
MSExcelClass.SetColumnWidth       PROCEDURE(STRING Column,LONG Width)
  CODE
    SELF.SetProperty('Columns("' & Column & '").ColumnWidth',Width)

!==============================================================================
MSExcelClass.SetColumnWidthByNumber PROCEDURE(LONG Column,LONG Width)
  CODE
    SELF.SetProperty('Columns(' & Column & ').ColumnWidth',Width)

!==============================================================================
MSExcelClass.SetGraphTitle        PROCEDURE(STRING Title)
  CODE
    SELF.SendCommand('ActiveChart.ChartArea.Select')
    SELF.SetProperty('ActiveChart.HasTitle',True)
    SELF.SetProperty('ActiveChart.ChartTitle.Characters.Text',Title)

!==============================================================================
MSExcelClass.SetHAlignment        PROCEDURE(BYTE Alignment)
  CODE
    SELF.SetProperty('Selection.HorizontalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetHAlignment        PROCEDURE(STRING Range,BYTE Alignment)
  CODE
    SELF.SetProperty('Range("' & Range & '").HorizontalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetHAlignment        PROCEDURE(LONG Row,LONG Column,BYTE Alignment)
  CODE
    SELF.SetProperty('Cells(' & Row & ',' & Column & ').HorizontalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetMargins           PROCEDURE(SHORT Top,SHORT Bottom,SHORT Left,SHORT Right)
  CODE
    SELF.SetProperty('Application.ActiveDocument.PageSetup.TopMargin',SELF.GetProperty('CentimetersToPoints(' & Top & ')'))
    SELF.SetProperty('Application.ActiveDocument.PageSetup.BottomMargin',SELF.GetProperty('CentimetersToPoints(' & Bottom & ')'))
    SELF.SetProperty('Application.ActiveDocument.PageSetup.LeftMargin',SELF.GetProperty('CentimetersToPoints(' & Left & ')'))
    SELF.SetProperty('Application.ActiveDocument.PageSetup.RightMargin',SELF.GetProperty('CentimetersToPoints(' & Right & ')'))

!==============================================================================
MSExcelClass.SetMergeCells        PROCEDURE(BYTE Merge)
  CODE
    SELF.SetProperty('Selection.MergeCells',Merge)

!==============================================================================
MSExcelClass.SetNumberFormat      PROCEDURE(STRING Format)
  CODE
    SELF.SetProperty('Selection.NumberFormat',Format)

!==============================================================================
MSExcelClass.SetNumberFormat      PROCEDURE(STRING Range,STRING Format)
  CODE
    SELF.SetProperty('Range("' & Range & '").NumberFormat',Format)

!==============================================================================
MSExcelClass.SetNumberFormat      PROCEDURE(LONG Row,LONG Column,STRING Format)
  CODE
    SELF.SetProperty('Cells(' & Row & ',' & Column & ').NumberFormat',Format)

!==============================================================================
MSExcelClass.SetRowHeight         PROCEDURE(LONG Height)
  CODE
    SELF.SetProperty('Selection.Rows.RowHeight',Height)

!==============================================================================
MSExcelClass.SetRowHeight         PROCEDURE(LONG Row,LONG Height)
  CODE
    SELF.SetProperty('Rows(' & Row & ').RowHeight',Height)

!==============================================================================
MSExcelClass.SetSheetName         PROCEDURE(SHORT Sheet,STRING Name)
  CODE
    SELF.SetProperty('Sheets(' & Sheet & ').Name',SUB(Name,1,31))

!==============================================================================
MSExcelClass.SetVAlignment        PROCEDURE(BYTE Alignment)
  CODE
    SELF.SetProperty('Selection.VerticalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetVAlignment        PROCEDURE(STRING Range,BYTE Alignment)
  CODE
    SELF.SetProperty('Range("' & Range & '").VerticalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetVAlignment        PROCEDURE(LONG Row,LONG Column,BYTE Alignment)
  CODE
    SELF.SetProperty('Cells(' & Row & ',' & Column & ').VerticalAlignment',Alignment)

!==============================================================================
MSExcelClass.SetWrapText          PROCEDURE(BYTE WrapText)
  CODE
    SELF.SetProperty('Selection.WrapText',WrapText)

!==============================================================================
MSExcelClass.SetWrapText          PROCEDURE(STRING Range,BYTE WrapText)
  CODE
    SELF.SetProperty('Range("' & Range & '").WrapText',WrapText)

!==============================================================================
MSExcelClass.SetWrapText          PROCEDURE(LONG Row,LONG Column,BYTE WrapText)
  CODE
    SELF.SetProperty('Cells(' & Row & ',' & Column & ').WrapText',WrapText)

!==============================================================================
MSExcelClass.SetXAxisTitle        PROCEDURE(STRING Title)
  CODE
    SELF.SendCommand('ActiveChart.ChartArea.Select')
    SELF.SetProperty('ActiveChart.Axes(1,1).HasTitle',True)
    SELF.SetProperty('ActiveChart.Axes(1,1).AxisTitle.Characters.Text',Title)

!==============================================================================
MSExcelClass.SetYAxisTitle        PROCEDURE(STRING Title)
  CODE
    SELF.SendCommand('ActiveChart.ChartArea.Select')
    SELF.SetProperty('ActiveChart.Axes(2,1).HasTitle',True)
    SELF.SetProperty('ActiveChart.Axes(2,1).AxisTitle.Characters.Text',Title)

!==============================================================================
MSExcelClass.SetZAxisTitle        PROCEDURE(STRING Title)
  CODE
    SELF.SendCommand('ActiveChart.ChartArea.Select')
    SELF.SetProperty('ActiveChart.Axes(3,1).HasTitle',True)
    SELF.SetProperty('ActiveChart.Axes(3,1).AxisTitle.Characters.Text',Title)

!==============================================================================
MSExcelClass.ShowLines            PROCEDURE(BYTE AxisType,BYTE Upper,BYTE Lower)
  CODE
    SELF.SendCommand('ActiveChart.PlotArea.Select')
    SELF.SetProperty('ActiveChart.Axes(' & AxisType & ').HasMajorGridlines',Upper)
    SELF.SetProperty('ActiveChart.Axes(' & AxisType & ').HasMinorGridlines',Lower)

!==============================================================================
MSExcelClass.Start                PROCEDURE()
  CODE
    SELF.Window $ SELF.Control{PROP:Create} = 'Excel.Application'
    PARENT.Start()

!==============================================================================
QuoteOT                             PROCEDURE(STRING Text)
TmpStr  CSTRING(OfficeTemplates:MaxLength + 1)
Pos     BYTE
Start   BYTE
  CODE
    TmpStr = Text
    Start  = 1
    LOOP
      Pos = INSTRING('"',TmpStr,1,Start)
      IF NOT Pos THEN BREAK.
      TmpStr = TmpStr[1 : Pos - 1] & '""' & TmpStr[Pos + 1 : LEN(TmpStr)]
      Start = Pos + 2
    END!LOOP
    RETURN TmpStr

!==============================================================================
