!--------------------------------------------------------------------------------!
!                                                                                !
! MSOfficeClass                                                                  !
!                                                                                !
! Microsoft Office Class                                                         !
!                                                                                !
! Copyright 1999 - SoftMasters (www.softmasters.com.ar)                         !
!                   Juan Domingo Herrera                                         !
!                   Matas Alejandro Flores                                      !
!                   Buenos Aires, Argentina                                      !
!                                                                                !
! Version: 2.0                                                                   !
!                                                                                !
!--------------------------------------------------------------------------------!

    MEMBER()

    MAP
    END!Map

    INCLUDE('ABOFFICE.INC'),ONCE

!==============================================================================
MSOfficeClass.Activate            PROCEDURE()
  CODE
    SELF.SendCommand('Application.Activate')

!==============================================================================
MSOfficeClass.Copy                PROCEDURE()
  CODE
    SELF.SendCommand('Selection.Copy')

!==============================================================================
MSOfficeClass.Cut                 PROCEDURE()
  CODE
    SELF.SendCommand('Selection.Cut')

!==============================================================================
MSOfficeClass.EndWith             PROCEDURE()
  CODE
    CLEAR(SELF.sWith)

!==============================================================================
MSOfficeClass.GetAlignment        PROCEDURE()
  CODE
    RETURN 0

!==============================================================================
MSOfficeClass.GetBold             PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.Bold')

!==============================================================================
MSOfficeClass.GetDisplayAlerts    PROCEDURE()
  CODE
    RETURN SELF.GetProperty('DisplayAlerts')

!==============================================================================
MSOfficeClass.GetFont             PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.Name')

!==============================================================================
MSOfficeClass.GetFontColor        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.ColorIndex')

!==============================================================================
MSOfficeClass.GetFontSize         PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.Size')

!==============================================================================
MSOfficeClass.GetItalic           PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.Italic')

!==============================================================================
MSOfficeClass.GetProperty         PROCEDURE(STRING Property)
ReturnValue STRING(OfficeTemplates:MaxLength)
  CODE
    UNLOCKTHREAD
    ReturnValue = SELF.Window $ SELF.Control{SELF.sWith & Property}
    LOCKTHREAD
    !----------------------------------------------------------------
    !added by Bjarne
    If UPPER(CLIP(ReturnValue)) = UPPER('No ole automation interface')
       Returnvalue = 0
    End
    !-------------------------------
    RETURN ReturnValue

!==============================================================================
MSOfficeClass.GetUnderline        PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.Font.Underline')

!==============================================================================
MSOfficeClass.GetVersion            PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Application.Version')

!==============================================================================
MSOfficeClass.GetVisible          PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Visible')

!==============================================================================
MSOfficeClass.Init                PROCEDURE(WINDOW Window,SIGNED Control,BYTE Start=True,BYTE Activate=True,BYTE Visible=True)
  CODE
    SELF.Window  &= Window
    SELF.Control  = Control
    IF Start AND ~SELF.IsRunning() THEN SELF.Start().
    IF Activate THEN SELF.Activate().
    SELF.SetVisible(Visible)

!==============================================================================
MSOfficeClass.IsRunning           PROCEDURE()
  CODE
    IF SELF.GetProperty('Application.Version') <> 0
      RETURN(True)
    ELSE
      RETURN(False)
    END!IF

!==============================================================================
MSOfficeClass.Maximize            PROCEDURE()
  CODE
    SELF.SetProperty('Application.WindowState',01h)

!==============================================================================
MSOfficeClass.Minimize            PROCEDURE()
  CODE
    SELF.SetProperty('Application.WindowState',02h)

!==============================================================================
MSOfficeClass.Paste               PROCEDURE()
  CODE
    SELF.SendCommand('Selection.Paste')

!==============================================================================
MSOfficeClass.Quit                PROCEDURE()
  CODE
    SELF.SendCommand('Quit')
    SELF.Window $ SELF.Control{PROP:DeActivate}

!==============================================================================
MSOfficeClass.RunMacro            PROCEDURE(STRING MacroName)
  CODE
    SELF.SendCommand('Application.Run(' & MacroName & ')')

!==============================================================================
MSOfficeClass.SendCommand         PROCEDURE(STRING OleCommand)
  CODE
    UNLOCKTHREAD
    A$ = SELF.Window $ SELF.Control{SELF.sWith & OleCommand}
    LOCKTHREAD

!==============================================================================
MSOfficeClass.SetAlignment        PROCEDURE(BYTE Justification)
  CODE
    RETURN

!==============================================================================
MSOfficeClass.SetBold             PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('Selection.Font.Bold',CHOOSE(State))

!==============================================================================
MSOfficeClass.SetDisplayAlerts    PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('DisplayAlerts',CHOOSE(State))

!==============================================================================
MSOfficeClass.SetFont             PROCEDURE(STRING FontName)
  CODE
    SELF.SetProperty('Selection.Font.Name',FontName)

!==============================================================================
MSOfficeClass.SetFontColor        PROCEDURE(LONG FontColor)
  CODE

!==============================================================================
MSOfficeClass.SetFontSize         PROCEDURE(SHORT FontSize)
  CODE
    SELF.SetProperty('Selection.Font.Size',FontSize)

!==============================================================================
MSOfficeClass.SetFormat           PROCEDURE(STRING FontName,SHORT FontSize,LONG FontColor,BYTE Bold,BYTE Italic,BYTE Justification)
  CODE
    IF FontName
      SELF.SetFont(FontName)
    END!IF
    SELF.SetFontSize(FontSize)
    SELF.SetBold(Bold)
    SELF.SetItalic(Italic)
    SELF.SetFontColor(FontColor)
    IF Justification
      SELF.SetAlignment(Justification)
    END!IF

!==============================================================================
MSOfficeClass.SetItalic           PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('Selection.Font.Italic',CHOOSE(State))

!==============================================================================
MSOfficeClass.SetProperty         PROCEDURE(STRING Property,STRING Value)
  CODE
    UNLOCKTHREAD
    SELF.Window $ SELF.Control{SELF.sWith & Property} = Value
    LOCKTHREAD

!==============================================================================
MSOfficeClass.SetReportException  PROCEDURE(BYTE State)
  CODE
    SELF.Window $ SELF.Control{PROP:ReportException} = CHOOSE(State)

!==============================================================================
MSOfficeClass.SetScreenUpdating   PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('ScreenUpdating',CHOOSE(State))

!==============================================================================
MSOfficeClass.SetUnderline        PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('Selection.Font.Underline',CHOOSE(State))

!==============================================================================
MSOfficeClass.SetVisible          PROCEDURE(BYTE State)
  CODE
    SELF.SetProperty('Visible',CHOOSE(State))

!==============================================================================
MSOfficeClass.Start               PROCEDURE()
  CODE
    SELF.Window $ SELF.Control{PROP:Language} = 0409H

!==============================================================================
MSOfficeClass.With                PROCEDURE(STRING With)
  CODE
    SELF.sWith = CLIP(With)

!==============================================================================
