!--------------------------------------------------------------------------------!
!                                                                                !
! MSOutlookClass                                                                 !
!                                                                                !
! Microsoft Outlook Class                                                        !
!                                                                                !
! Copyright 1999 - SoftMasters (www.softmasters.com.ar)                         !
!                   Juan Domingo Herrera                                         !
!                   Matas Alejandro Flores                                      !
!                   Buenos Aires, Argentina                                      !
!                                                                                !
! Version: 2.0                                                                   !
!                                                                                !
!--------------------------------------------------------------------------------!

    MEMBER()

    INCLUDE('ABOUT.INC'),ONCE

    MAP
      QuoteOT(STRING Text),STRING
    END!MAP

!==============================================================================
MSOutlookClass.AddAttach            PROCEDURE(STRING FileName)
Attachments CSTRING(20)
  CODE
    Attachments = SELF.GetProperty(SELF.Object & '.Attachments')
    SELF.SendCommand(Attachments & '.Add(' & FileName & ')')

!==============================================================================
MSOutlookClass.Close                PROCEDURE()
  CODE
    SELF.SendCommand(SELF.Object & '.Close(' & SELF.SaveMode & ')')

!==============================================================================
MSOutlookClass.CreateItem           PROCEDURE(STRING Item)
  CODE
    CASE UPPER(Item)
      OF 'APPOINTMENT'
        SELF.Object = SELF.GetProperty('CreateItem(' & olAppointmentItem & ')')
      OF 'CONTACT'
        SELF.Object = SELF.GetProperty('CreateItem(' &   olContactItem   & ')')
      OF 'JOURNAL'
        SELF.Object = SELF.GetProperty('CreateItem(' &   olJournalItem   & ')')
      OF 'MAIL'
        SELF.Object = SELF.GetProperty('CreateItem(' &    olMailItem     & ')')
      OF 'NOTE'
        SELF.Object = SELF.GetProperty('CreateItem(' &    olNoteItem     & ')')
      OF 'POST'
        SELF.Object = SELF.GetProperty('CreateItem(' &    olPostItem     & ')')
      OF 'TASK'
        SELF.Object = SELF.GetProperty('CreateItem(' &    olTaskItem     & ')')
    END!CASE

!==============================================================================
MSOutlookClass.Delete               PROCEDURE(STRING ItemId)
  CODE
    IF ItemId = ''
      SELF.SendCommand(SELF.Object & '.Delete')
    ELSE
      SELF.Search(ItemId)
      SELF.SendCommand(SELF.Object & '.Delete')
    END!IF

!==============================================================================
MSOutlookClass.DisplayMessage       PROCEDURE()
  CODE
    SELF.SendCommand(SELF.Object & '.Display')

!==============================================================================
MSOutlookClass.GetAlignment         PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.HorizontalAlignment')

!==============================================================================
MSOutlookClass.Init                 PROCEDURE(WINDOW Window,SIGNED Control,BYTE Start=True,BYTE Activate=True,BYTE Visible=True)
  CODE
    Parent.Init(Window,Control,Start,Activate,Visible)
    SELF.NameSpace = SELF.GetProperty('GetNameSpace("MAPI")')
    SELF.Calendar  = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderCalendar & ').Items')
    SELF.Contacts  = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderContacts & ').Items')
    SELF.Inbox     = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderInbox    & ').Items')
    SELF.Journal   = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderJournal  & ').Items')
    SELF.Notes     = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderNotes    & ').Items')
    SELF.Outbox    = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderOutbox   & ').Items')
    SELF.SentMail  = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderSentMail & ').Items')
    SELF.Tasks     = SELF.GetProperty(SELF.NameSpace & '.GetDefaultFolder(' & olFolderTasks    & ').Items')

!==============================================================================
MSOutlookClass.MarkComplete         PROCEDURE(STRING ItemId)
  CODE
    IF ItemId = ''
      SELF.SendCommand(SELF.Object & '.MarkComplete')
    ELSE
      SELF.Search(ItemId)
      SELF.SendCommand(SELF.Object & '.MarkComplete')
    END!IF

!==============================================================================
MSOutlookClass.PrintItem            PROCEDURE(STRING ItemId)
  CODE
    IF ItemId = ''
      SELF.SendCommand(SELF.Object & '.PrintOut')
    ELSE
      SELF.Search(ItemId)
      SELF.SendCommand(SELF.Object & '.PrintOut')
    END!IF

!==============================================================================
MSOutlookClass.Save                 PROCEDURE()
  CODE
    SELF.SendCommand(SELF.Object & '.Save')
    SELF.SendCommand(SELF.Object & '.EntryID')
    RETURN(SELF.GetProperty(SELF.Object & '.EntryID'))

!==============================================================================
MSOutlookClass.SaveAs               PROCEDURE(STRING FileName,BYTE Format)
  CODE
    SELF.SendCommand(SELF.Object & '.SaveAs(' & FileName & ',' & Format & ')')

!==============================================================================
MSOutlookClass.Search               PROCEDURE(STRING EntryId)
  CODE
    SELF.Object = SELF.GetProperty(SELF.NameSpace & '.GetItemFromID("' & CLIP(EntryId) & '")')

!==============================================================================
MSOutlookClass.Send                 PROCEDURE()
  CODE
    SELF.SendCommand(SELF.Object & '.Send')

!==============================================================================
MSOutlookClass.Send                 PROCEDURE(STRING ConfirmText,STRING CancelledText)
  CODE
    IF MESSAGE(ConfirmText,'Confirmation',ICON:Question,BUTTON:No+BUTTON:Yes) = BUTTON:Yes
      SELF.Send()
    ELSE
      MESSAGE(CancelledText,'Message Cancelled',ICON:Exclamation)
    END!IF

!==============================================================================
MSOutlookClass.SetAlignment         PROCEDURE(BYTE Justification)
  CODE
    SELF.SetProperty('Selection.HorizontalAlignment',Justification)

!==============================================================================
MSOutlookClass.Start                PROCEDURE()
  CODE
    SELF.Window $ SELF.Control{PROP:Create} = 'Outlook.Application'
    PARENT.Start()

!==============================================================================
! Calendar Methods
!==============================================================================
MSOutlookClass.FindAppointment      PROCEDURE(STRING Filter)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Calendar & '.Find("' & Filter & '")')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.FindAppointmentBySubject PROCEDURE(STRING Subject)
  CODE
    RETURN SELF.FindAppointment('[Subject] = ''' & Subject & '''')

!==============================================================================
MSOutlookClass.FindNextAppointment  PROCEDURE()
  CODE
    SELF.Object = SELF.GetProperty(SELF.Calendar & '.FindNext()')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetAppointment       PROCEDURE(LONG Index)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Calendar & '.Item(' & Index & ')')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetCalendarCount     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Calendar & '.Count')

!==============================================================================
! Contacts Methods
!==============================================================================
MSOutlookClass.FindContact          PROCEDURE(STRING Filter)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Contacts & '.Find("' & Filter & '")')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.FindContactByCompany PROCEDURE(STRING Company)
  CODE
    RETURN SELF.FindContact('[Company] = ''' & Company & '''')

!==============================================================================
MSOutlookClass.FindContactByCustomerId PROCEDURE(STRING Id)
  CODE
    RETURN SELF.FindContact('[CustomerId] = ''' & Id & '''')

!==============================================================================
MSOutlookClass.FindContactByEmail PROCEDURE(STRING Email)
  CODE
    RETURN SELF.FindContact('[Email1Address] = ''' & Email & '''')

!==============================================================================
MSOutlookClass.FindContactByFullName PROCEDURE(STRING FullName)
  CODE
    RETURN SELF.FindContact('[FullName] = ''' & FullName & '''')

!==============================================================================
MSOutlookClass.FindNextContact      PROCEDURE()
  CODE
    SELF.Object = SELF.GetProperty(SELF.Contacts & '.FindNext()')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetContact           PROCEDURE(LONG Index)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Contacts & '.Item(' & Index & ')')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetContactsCount     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Contacts & '.Count')

!==============================================================================
MSOutlookClass.GetAccount           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Account')

!==============================================================================
MSOutlookClass.GetAnniversary       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Anniversary')

!==============================================================================
MSOutlookClass.GetAssistantName     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.AssistantName')

!==============================================================================
MSOutlookClass.GetAssistantPhone    PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.AssistantTelephoneNumber')

!==============================================================================
MSOutlookClass.GetBeeper            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.CallbackTelephoneNumber')

!==============================================================================
MSOutlookClass.GetBirthday          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Birthday')

!==============================================================================
MSOutlookClass.GetBusinessAddress   PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddress')

!==============================================================================
MSOutlookClass.GetBusinessCity      PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddressCity')

!==============================================================================
MSOutlookClass.GetBusinessCountry   PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddressCountry')

!==============================================================================
MSOutlookClass.GetBusinessFax       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessFaxNumber')

!==============================================================================
MSOutlookClass.GetBusinessHomePage  PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessHomePage')

!==============================================================================
MSOutlookClass.GetBusinessPCode     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddressPostalCode')

!==============================================================================
MSOutlookClass.GetBusinessPhone     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessTelephoneNumber')

!==============================================================================
MSOutlookClass.GetBusinessPhone2    PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Business2TelephoneNumber')

!==============================================================================
MSOutlookClass.GetBusinessState     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddressState')

!==============================================================================
MSOutlookClass.GetBusinessStreet    PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BusinessAddressStreet')

!==============================================================================
MSOutlookClass.GetCompanyAndFullName PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.CompanyAndFullName')

!==============================================================================
MSOutlookClass.GetCompanyName       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.CompanyName')

!==============================================================================
MSOutlookClass.GetCustomerID        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.CustomerID')

!==============================================================================
MSOutlookClass.GetDepartment        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Department')

!==============================================================================
MSOutlookClass.GetEMail1            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.EMail1Address')

!==============================================================================
MSOutlookClass.GetEMail1ID          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email1EntryID')

!==============================================================================
MSOutlookClass.GetEMail2            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email2Address')

!==============================================================================
MSOutlookClass.GetEMail2ID          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email2EntryID')

!==============================================================================
MSOutlookClass.GetEMail3            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email3Address')

!==============================================================================
MSOutlookClass.GetEMail3ID          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email3EntryID')

!==============================================================================
MSOutlookClass.GetEMailName1        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email1DisplayName')

!==============================================================================
MSOutlookClass.GetEMailName2        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email2DisplayName')

!==============================================================================
MSOutlookClass.GetEMailName3        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Email3DisplayName')

!==============================================================================
MSOutlookClass.GetFTPSite           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.FTPSite')

!==============================================================================
MSOutlookClass.GetFirstName         PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.FirstName')

!==============================================================================
MSOutlookClass.GetFullName          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Fullname')

!==============================================================================
MSOutlookClass.GetGender            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Gender')

!==============================================================================
MSOutlookClass.GetHomeAddress   PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddress')

!==============================================================================
MSOutlookClass.GetHomeCity      PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddressCity')

!==============================================================================
MSOutlookClass.GetHomeCountry   PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddressCountry')

!==============================================================================
MSOutlookClass.GetHomeFax       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeFaxNumber')

!==============================================================================
MSOutlookClass.GetHomePCode     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddressPostalCode')

!==============================================================================
MSOutlookClass.GetHomePhone     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeTelephoneNumber')

!==============================================================================
MSOutlookClass.GetHomePhone2    PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Home2TelephoneNumber')

!==============================================================================
MSOutlookClass.GetHomeState     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddressState')

!==============================================================================
MSOutlookClass.GetHomeStreet    PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.HomeAddressStreet')

!==============================================================================
MSOutlookClass.GetMobilePhone       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.MobileTelephoneNumber')

!==============================================================================
MSOutlookClass.SetAccount           PROCEDURE(STRING Account)
  CODE
    SELF.SetProperty(SELF.Object & '.Account',Account)

!==============================================================================
MSOutlookClass.SetAnniversary       PROCEDURE(STRING Anniversary)
  CODE
    SELF.SetProperty(SELF.Object & '.Anniversary',Anniversary)

!==============================================================================
MSOutlookClass.SetAssistantName     PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.AssistantName',Name)

!==============================================================================
MSOutlookClass.SetAssistantPhone    PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.AssistantTelephoneNumber',Phone)

!==============================================================================
MSOutlookClass.SetBeeper            PROCEDURE(STRING Beeper)
  CODE
    SELF.SetProperty(SELF.Object & '.CallbackTelephoneNumber',Beeper)

!==============================================================================
MSOutlookClass.SetBirthday          PROCEDURE(STRING Birthday)
  CODE
    SELF.SetProperty(SELF.Object & '.Birthday',Birthday)

!==============================================================================
MSOutlookClass.SetBusinessAddress   PROCEDURE(STRING Address)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddress',Address)

!=============================================================================
MSOutlookClass.SetBusinessCity      PROCEDURE(STRING City)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddressCity',City)

!==============================================================================
MSOutlookClass.SetBusinessCountry   PROCEDURE(STRING Country)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddressCountry',Country)

!==============================================================================
MSOutlookClass.SetBusinessFax       PROCEDURE(STRING Fax)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessFaxNumber',Fax)

!==============================================================================
MSOutlookClass.SetBusinessHomePage  PROCEDURE(STRING Address)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessHomePage',Address)

!==============================================================================
MSOutlookClass.SetBusinessPCode     PROCEDURE(STRING PC)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddressPostalCode',PC)

!==============================================================================
MSOutlookClass.SetBusinessPhone     PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessTelephoneNumber',Phone)

!==============================================================================
MSOutlookClass.SetBusinessPhone2    PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.Business2TelephoneNumber',Phone)

!==============================================================================
MSOutlookClass.SetBusinessState     PROCEDURE(STRING State)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddressState',State)

!==============================================================================
MSOutlookClass.SetBusinessStreet    PROCEDURE(STRING Street)
  CODE
    SELF.SetProperty(SELF.Object & '.BusinessAddressStreet',Street)

!==============================================================================
MSOutlookClass.SetCompanyName       PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.CompanyName',Name)

!==============================================================================
MSOutlookClass.SetCustomerID        PROCEDURE(STRING ID)
  CODE
    SELF.SetProperty(SELF.Object & '.CustomerID',ID)

!==============================================================================
MSOutlookClass.SetDepartment        PROCEDURE(STRING Area)
  CODE
    SELF.SetProperty(SELF.Object & '.Department',Area)

!==============================================================================
MSOutlookClass.SetEMail1            PROCEDURE(STRING EMail)
  CODE
    SELF.SetProperty(SELF.Object & '.EMail1Address',EMail)

!==============================================================================
MSOutlookClass.SetEMail2            PROCEDURE(STRING EMail)
  CODE
    SELF.SetProperty(SELF.Object & '.Email2Address',EMail)

!==============================================================================
MSOutlookClass.SetEMail3            PROCEDURE(STRING EMail)
  CODE
    SELF.SetProperty(SELF.Object & '.Email3Address',EMail)

!==============================================================================
MSOutlookClass.SetEMailName1        PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.Email1DisplayName',Name)

!==============================================================================
MSOutlookClass.SetEMailName2        PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.Email2DisplayName',Name)

!==============================================================================
MSOutlookClass.SetEMailName3        PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.Email3DisplayName',Name)

!==============================================================================
MSOutlookClass.SetFTPSite           PROCEDURE(STRING FTP)
  CODE
    SELF.SetProperty(SELF.Object & '.FTPSite',FTP)

!==============================================================================
MSOutlookClass.SetFirstName         PROCEDURE(STRING Name)
  CODE
    SELF.SetProperty(SELF.Object & '.FirstName',Name)

!==============================================================================
MSOutlookClass.SetFullName          PROCEDURE(STRING FullName)
  CODE
    SELF.SetProperty(SELF.Object & '.Fullname',FullName)

!==============================================================================
MSOutlookClass.SetGender            PROCEDURE(LONG Gender)
  CODE
    SELF.SetProperty(SELF.Object & '.Gender',Gender)

!==============================================================================
MSOutlookClass.SetHomeAddress   PROCEDURE(STRING Address)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddress',Address)

!=============================================================================
MSOutlookClass.SetHomeCity      PROCEDURE(STRING City)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddressCity',City)

!==============================================================================
MSOutlookClass.SetHomeCountry   PROCEDURE(STRING Country)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddressCountry',Country)

!==============================================================================
MSOutlookClass.SetHomeFax       PROCEDURE(STRING Fax)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeFaxNumber',Fax)

!==============================================================================
MSOutlookClass.SetHomePCode     PROCEDURE(STRING PC)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddressPostalCode',PC)

!==============================================================================
MSOutlookClass.SetHomePhone     PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeTelephoneNumber',Phone)

!==============================================================================
MSOutlookClass.SetHomePhone2    PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.Home2TelephoneNumber',Phone)

!==============================================================================
MSOutlookClass.SetHomeState     PROCEDURE(STRING State)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddressState',State)

!==============================================================================
MSOutlookClass.SetHomeStreet    PROCEDURE(STRING Street)
  CODE
    SELF.SetProperty(SELF.Object & '.HomeAddressStreet',Street)

!==============================================================================
MSOutlookClass.SetMobilePhone       PROCEDURE(STRING Phone)
  CODE
    SELF.SetProperty(SELF.Object & '.MobileTelephoneNumber',Phone)

!==============================================================================
! Journal Methods
!==============================================================================
MSOutlookClass.FindJournal          PROCEDURE(STRING Filter)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Journal & '.Find("' & Filter & '")')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.FindJournalBySubject PROCEDURE(STRING Subject)
  CODE
    RETURN SELF.FindJournal('[Subject] = ''' & Subject & '''')

!==============================================================================
MSOutlookClass.FindNextJournal      PROCEDURE()
  CODE
    SELF.Object = SELF.GetProperty(SELF.Journal & '.FindNext()')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetJournal           PROCEDURE(LONG Index)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Journal & '.Item(' & Index & ')')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetJournalCount      PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Journal & '.Count')

!==============================================================================
! Mails Methods
!==============================================================================
MSOutlookClass.GetInboxCount        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Inbox & '.Count')

!==============================================================================
MSOutlookClass.GetOutboxCount       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Outbox & '.Count')

!==============================================================================
MSOutlookClass.GetSentMailCount     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.SentMail & '.Count')

!==============================================================================
MSOutlookClass.GetBCC               PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BCC')

!==============================================================================
MSOutlookClass.GetCC                PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.CC')

!==============================================================================
MSOutlookClass.GetFrom              PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.From')

!==============================================================================
MSOutlookClass.GetTo                PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.To')

!==============================================================================
MSOutlookClass.SetBCC               PROCEDURE(STRING BCC)
  CODE
    SELF.SetProperty(SELF.Object & '.BCC',BCC)

!==============================================================================
MSOutlookClass.SetCC                PROCEDURE(STRING CC)
  CODE
    SELF.SetProperty(SELF.Object & '.CC',CC)

!==============================================================================
MSOutlookClass.SetFrom              PROCEDURE(STRING From)
  CODE
    SELF.SetProperty(SELF.Object & '.From',From)

!==============================================================================
MSOutlookClass.SetTo                PROCEDURE(STRING To)
  CODE
    SELF.SetProperty(SELF.Object & '.To',To)

!==============================================================================
! Notes Methods
!==============================================================================
MSOutlookClass.FindNote             PROCEDURE(STRING Filter)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Notes & '.Find("' & Filter & '")')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.FindNoteBySubject PROCEDURE(STRING Subject)
  CODE
    RETURN SELF.FindNote('[Subject] = ''' & Subject & '''')

!==============================================================================
MSOutlookClass.FindNextNote         PROCEDURE()
  CODE
    SELF.Object = SELF.GetProperty(SELF.Notes & '.FindNext()')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetNote              PROCEDURE(LONG Index)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Notes & '.Item(' & Index & ')')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetNotesCount        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Notes & '.Count')

!==============================================================================
MSOutlookClass.GetHeight            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Heigth')
    
!==============================================================================
MSOutlookClass.GetLeft              PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Left')

!==============================================================================
MSOutlookClass.GetPostItColor       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Color')

!==============================================================================
MSOutlookClass.GetTop               PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Top')

!==============================================================================
MSOutlookClass.GetWidth             PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Width')

!==============================================================================
MSOutlookClass.SetHeight            PROCEDURE(LONG Height)
  CODE
    SELF.SetProperty(SELF.Object & '.Height',Height)

!==============================================================================
MSOutlookClass.SetLeft              PROCEDURE(LONG XPos)
  CODE
    SELF.SetProperty(SELF.Object & '.Left',XPos)

!==============================================================================
MSOutlookClass.SetPosition          PROCEDURE(LONG XPos,LONG YPos)
  CODE
    SELF.SetLeft(XPos)
    SELF.SetTop(YPos)

!==============================================================================
MSOutlookClass.SetPostItColor       PROCEDURE(BYTE Color)
  CODE
    SELF.SetProperty(SELF.Object & '.Color',Color)

!==============================================================================
MSOutlookClass.SetTop               PROCEDURE(LONG YPos)
  CODE
    SELF.SetProperty(SELF.Object & '.Top',YPos)

!==============================================================================
MSOutlookClass.SetWidth             PROCEDURE(LONG Width)
  CODE
    SELF.SetProperty(SELF.Object & '.Width',Width)

!==============================================================================
! Tasks Methods
!==============================================================================
MSOutlookClass.FindTask             PROCEDURE(STRING Filter)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Tasks & '.Find("' & Filter & '")')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.FindTaskByDueDate PROCEDURE(STRING DueDate)
  CODE
    RETURN SELF.FindTask('[DueDate] = ''' & DueDate & '''')

!==============================================================================
MSOutlookClass.FindTaskByStartDate PROCEDURE(STRING StartDate)
  CODE
    RETURN SELF.FindTask('[StartDate] = ''' & StartDate & '''')

!==============================================================================
MSOutlookClass.FindTaskByStatus PROCEDURE(STRING Status)
  CODE
    RETURN SELF.FindTask('[Status] = ''' & Status & '''')

!==============================================================================
MSOutlookClass.FindTaskBySubject PROCEDURE(STRING Subject)
  CODE
    RETURN SELF.FindTask('[Subject] = ''' & Subject & '''')

!==============================================================================
MSOutlookClass.FindNextTask         PROCEDURE()
  CODE
    SELF.Object = SELF.GetProperty(SELF.Tasks & '.FindNext()')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetTask              PROCEDURE(LONG Index)
  CODE
    SELF.Object = SELF.GetProperty(SELF.Tasks & '.Item(' & Index & ')')
    IF SELF.Object
      RETURN 0
    ELSE
      RETURN 5
    END!IF

!==============================================================================
MSOutlookClass.GetTasksCount        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Tasks & '.Count')

!==============================================================================
MSOutlookClass.GetActualWork        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.ActualWork')

!==============================================================================
MSOutlookClass.GetDateCompleted     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.DateCompleted')

!==============================================================================
MSOutlookClass.GetDueDate           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.DueDate')

!==============================================================================
MSOutlookClass.GetOrdinal           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Ordinal')

!==============================================================================
MSOutlookClass.GetPercentComplete   PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.PercentComplete')

!==============================================================================
MSOutlookClass.GetStartDate         PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.StartDate')

!==============================================================================
MSOutlookClass.GetStatus            PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Status')

!==============================================================================
MSOutlookClass.GetTotalWork         PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.TotalWork')

!==============================================================================
MSOutlookClass.SetActualWork        PROCEDURE(LONG Minutes)
  CODE
    SELF.SetProperty(SELF.Object & '.ActualWork',Minutes)

!==============================================================================
MSOutlookClass.SetDateCompleted     PROCEDURE(STRING DateCompleted)
  CODE
    SELF.SetProperty(SELF.Object & '.DateCompleted',DateCompleted)

!==============================================================================
MSOutlookClass.SetDueDate           PROCEDURE(STRING DueDate)
  CODE
    SELF.SetProperty(SELF.Object & '.DueDate',DueDate)

!==============================================================================
MSOutlookClass.SetOrdinal           PROCEDURE(SHORT Ordinal)
  CODE
    SELF.SetProperty(SELF.Object & '.Ordinal',Ordinal)

!==============================================================================
MSOutlookClass.SetPercentComplete   PROCEDURE(SHORT Percent)
  CODE
    SELF.SetProperty(SELF.Object & '.PercentComplete',Percent)

!==============================================================================
MSOutlookClass.SetStartDate         PROCEDURE(STRING StartDate)
  CODE
    SELF.SetProperty(SELF.Object & '.StartDate',StartDate)

!==============================================================================
MSOutlookClass.SetStatus            PROCEDURE(BYTE Status)
  CODE
    SELF.SetProperty(SELF.Object & '.Status',Status)

!==============================================================================
MSOutlookClass.SetTotalWork         PROCEDURE(LONG Minutes)
  CODE
    SELF.SetProperty(SELF.Object & '.TotalWork',Minutes)

!==============================================================================
! Multi-Item Methods
!==============================================================================
MSOutlookClass.GetBilling           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.BillingInformation')

!==============================================================================
MSOutlookClass.GetBody              PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Body')

!==============================================================================
MSOutlookClass.GetCompanies         PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Companies')

!==============================================================================
MSOutlookClass.GetCustomField       PROCEDURE(STRING Field)
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.UserProperties("' & Field & '").Value')

!==============================================================================
MSOutlookClass.GetEnd               PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.End')

!==============================================================================
MSOutlookClass.GetEntryId           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.EntryId')

!==============================================================================
MSOutlookClass.GetImportance        PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Importance')

!==============================================================================
MSOutlookClass.GetMileage           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Mileage')

!==============================================================================
MSOutlookClass.GetReminder          PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.ReminderTime') & ',' & SELF.GetProperty(SELF.Object & '.ReminderTime')

!==============================================================================
MSOutlookClass.GetReminderSound     PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.ReminderSoundFile')

!==============================================================================
MSOutlookClass.GetSensitivity       PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Sensitivity')

!==============================================================================
MSOutlookClass.GetStart             PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Start')

!==============================================================================
MSOutlookClass.GetSubject           PROCEDURE()
  CODE
    RETURN SELF.GetProperty(SELF.Object & '.Subject')

!==============================================================================
MSOutlookClass.SetBilling           PROCEDURE(STRING Text)
  CODE
    SELF.SetProperty(SELF.Object & '.BillingInformation',Text)

!==============================================================================
MSOutlookClass.SetBody              PROCEDURE(STRING Body)
  CODE
    SELF.SetProperty(SELF.Object & '.Body',Body)

!==============================================================================
MSOutlookClass.SetCompanies         PROCEDURE(STRING Companies)
  CODE
    SELF.SetProperty(SELF.Object & '.Companies',Companies)

!==============================================================================
MSOutlookClass.SetCustomField       PROCEDURE(STRING Field,STRING Value)
  CODE
    SELF.SetProperty(SELF.Object & '.UserProperties("' & Field & '").Value',Value)

!==============================================================================
MSOutlookClass.SetEnd               PROCEDURE(STRING EndDate,STRING EndTime)
  CODE
    SELF.SetProperty(SELF.Object & '.End',EndDate & ' ' & EndTime)

!==============================================================================
MSOutlookClass.SetHTMLBody          PROCEDURE(STRING HTMLBody)
  CODE
    SELF.SetProperty(SELF.Object & '.HTMLBody',HTMLBody)

!==============================================================================
MSOutlookClass.SetImportance        PROCEDURE(BYTE Importance)
  CODE
    SELF.SetProperty(SELF.Object & '.Importance',Importance)

!==============================================================================
MSOutlookClass.SetMileage           PROCEDURE(STRING Text)
  CODE
    SELF.SetProperty(SELF.Object & '.Mileage',Text)

!==============================================================================
MSOutlookClass.SetReminder          PROCEDURE(STRING ReminderDate,STRING ReminderTime)
  CODE
    SELF.SetProperty(SELF.Object & '.ReminderSet',True)
    SELF.SetProperty(SELF.Object & '.ReminderTime',ReminderDate & ' ' & ReminderTime)

!==============================================================================
MSOutlookClass.SetReminderSound     PROCEDURE(STRING FileName)
  CODE
    SELF.SetProperty(SELF.Object & '.ReminderOverrideDefault',True)
    SELF.SetProperty(SELF.Object & '.ReminderPlaySound',True)
    SELF.SetProperty(SELF.Object & '.ReminderSoundFile',FileName)

!==============================================================================
MSOutlookClass.SetSensitivity       PROCEDURE(BYTE Type)
  CODE
    SELF.SetProperty(SELF.Object & '.Sensitivity',Type)

!==============================================================================
MSOutlookClass.SetStart             PROCEDURE(STRING StartDate,STRING StartTime)
  CODE
    SELF.SetProperty(SELF.Object & '.Start',StartDate & ' ' & StartTime)

!==============================================================================
MSOutlookClass.SetSubject           PROCEDURE(STRING Subject)
  CODE
    SELF.SetProperty(SELF.Object & '.Subject',Subject)

!==============================================================================
QuoteOT                               PROCEDURE(STRING Text)
TmpStr  CSTRING(OfficeTemplates:MaxLength + 1)
Pos     BYTE
Start   BYTE
  CODE
    TmpStr = Text
    Start  = 1
    LOOP
      Pos = INSTRING('"',TmpStr,1,Start)
      IF NOT Pos THEN BREAK.
      TmpStr = TmpStr[1 : Pos - 1] & '""' & TmpStr[Pos + 1 : LEN(TmpStr)]
      Start = Pos + 2
    END!LOOP
    RETURN TmpStr

!==============================================================================
