!--------------------------------------------------------------------------------!
!                                                                                !
! MSWordClass                                                                    !
!                                                                                !
! Microsoft Word Class                                                           !
!                                                                                !
! Copyright 1999 - SoftMasters (www.softmasters.com.ar)                         !
!                   Juan Domingo Herrera                                         !
!                   Matas Alejandro Flores                                      !
!                   Buenos Aires, Argentina                                      !
!                                                                                !
! Version: 2.0                                                                   !
!                                                                                !
!--------------------------------------------------------------------------------!

    MEMBER()

    INCLUDE('ABWORD.INC'),ONCE

    MAP
      QuoteOT(STRING Text),STRING
      MODULE('')
        FnSplit(*cstring,*cstring,*cstring,*cstring,*cstring),short,raw,name('_fnsplit')
      END
    END!MAP

!==============================================================================
MSWordClass.AddMergeField         PROCEDURE(STRING pSearch,STRING pField,BYTE pWhere,BYTE MatchCase=False,BYTE MatchWholeWord=True,BYTE MAtchWildCards=False,BYTE StartFromBeginning=True)
pRange      CSTRING(20)
ViewType    BYTE
OriginalView    BYTE
  CODE
    IF pWhere
      OriginalView = SELF.GetProperty('ActiveWindow.ActivePane.View.SeekView')
      Do ActivateHeader
      Do FillSearchOptions
      R# = SELF.GetProperty('Selection.Find.Execute')
      LOOP WHILE R# = -1
        Do Replacement
        Do FillSearchOptions
        R# = SELF.GetProperty('Selection.Find.Execute')
      END
      Do ActivateFooter
      Do FillSearchOptions
      R# = SELF.GetProperty('Selection.Find.Execute')
      LOOP WHILE R# = -1
        Do Replacement
        Do FillSearchOptions
        R# = SELF.GetProperty('Selection.Find.Execute')
      END
      SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',OriginalView)
    END
    Do FillSearchOptions
    R# = SELF.GetProperty('Selection.Find.Execute')
    LOOP WHILE R# = -1
      Do Replacement
      Do FillSearchOptions
      R# = SELF.GetProperty('Selection.Find.Execute')
    END
    RETURN R#

FillSearchOptions   ROUTINE
    IF StartFromBeginning
      SELF.SendCommand('Selection.HomeKey(6)')
    END
    SELF.SendCommand('Selection.Find.ClearFormatting')
    SELF.SetProperty('Selection.Find.Text',pSearch)
    SELF.SetProperty('Selection.Find.Forward',True)
    SELF.SetProperty('Selection.Find.Wrap',True)
    SELF.SetProperty('Selection.Find.Format',False)
    SELF.SetProperty('Selection.Find.MatchCase',MatchCase)
    SELF.SetProperty('Selection.Find.MatchWholeWord',MatchWholeWord)
    SELF.SetProperty('Selection.Find.MatchWildcards',MatchWildcards)
    SELF.SetProperty('Selection.Find.MatchSoundsLike',False)
    SELF.SetProperty('Selection.Find.MatchAllWordForms',False)

ActivateHeader      ROUTINE
    ViewType = SELF.GetProperty('ActiveWindow.ActivePane.View.Type')
    IF ViewType = wdNormalView Or ViewType = wdOutlineView
        SELF.SetProperty('ActiveWindow.ActivePane.View.Type',wdPrintView)
    END
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',wdSeekCurrentPageHeader)

ActivateFooter      ROUTINE
    ViewType = SELF.GetProperty('ActiveWindow.ActivePane.View.Type')
    IF ViewType = wdNormalView Or ViewType = wdOutlineView
        SELF.SetProperty('ActiveWindow.ActivePane.View.Type',wdPrintView)
    END
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',wdSeekCurrentPageFooter)
    
Replacement         ROUTINE
    pRange = SELF.GetProperty('Selection.Range')
    SELF.SendCommand('ActiveDocument.Content.Find.Execute("' & pSearch & '")')
    SELF.SendCommand('ActiveDocument.Fields.Add(' & CLIP(pRange) & ',' & CLIP(wdFieldMergeField) & ',"' & CLIP(pField) & '")')
    SELF.SendCommand('Selection.Find.ClearFormatting')    

!==============================================================================
MSWordClass.CheckGrammar          PROCEDURE()
  CODE
    SELF.SendCommand('ActiveDocument.CheckGrammar')

!==============================================================================
MSWordClass.CheckSpelling         PROCEDURE()
  CODE
    SELF.SendCommand('ActiveDocument.CheckSpelling')

!==============================================================================
MSWordClass.CloseDoc              PROCEDURE()
  CODE
    SELF.SendCommand('Document.Close')

!==============================================================================
MSWordClass.CloseDoc              PROCEDURE(BYTE SaveChanges)
  CODE
    SELF.SendCommand('Document.Close('&SaveChanges&')')

!==============================================================================
MSWordClass.CloseAllDocs          PROCEDURE()
  CODE
    SELF.SendCommand('Documents.Close')

!==============================================================================
MSWordClass.CloseAllDocs          PROCEDURE(BYTE SaveChanges)
  CODE
    SELF.SendCommand('Documents.Close('&SaveChanges&')')

!==============================================================================
MSWordClass.CreateDoc             PROCEDURE()
  CODE
    SELF.SendCommand('Documents.Add')

!==============================================================================
MSWordClass.CreateDoc             PROCEDURE(STRING FileName)
  CODE
    SELF.SendCommand('Documents.Add("' & FileName & '")')

!==============================================================================
MSWordClass.CreateTable           PROCEDURE(SHORT Style,SHORT Lines,BYTE AutoFit)
  CODE
    SELF.SendCommand('Application.Selection.MoveUp(5,' & Lines & ',1)')
    SELF.SendCommand('Application.Selection.ConvertToTable(1,,,,' & Style & ')')
    IF AutoFit = 1
      SELF.SendCommand('Application.Selection.Cells.AutoFit')
    END!IF
    SELF.SendCommand('Application.Selection.MoveDown(5,1)')

!==============================================================================
MSWordClass.CursorDown            PROCEDURE(SHORT Units,SHORT Unit=wdLine,BYTE Selecting=0)
  CODE
    RETURN SELF.GetProperty('Selection.MoveDown(' & Unit & ',' & Units & ',' & CHOOSE(Selecting) & ')')

!==============================================================================
MSWordClass.CursorLeft            PROCEDURE(SHORT Units,SHORT Unit=wdCharacter,BYTE Selecting=0)
  CODE
    RETURN SELF.GetProperty('Selection.MoveLeft(' & Unit & ',' & Units & ',' & CHOOSE(Selecting) & ')')

!==============================================================================
MSWordClass.CursorRight           PROCEDURE(SHORT Units,SHORT Unit=wdCharacter,BYTE Selecting=0)
  CODE
    RETURN SELF.GetProperty('Selection.MoveRight(' & Unit & ',' & Units & ',' & CHOOSE(Selecting) & ')')

!==============================================================================
MSWordClass.CursorUp              PROCEDURE(SHORT Units,SHORT Unit=wdLine,BYTE Selecting=0)
  CODE
    RETURN SELF.GetProperty('Selection.MoveUp(' & Unit & ',' & Units & ',' & CHOOSE(Selecting) & ')')

!==============================================================================
MSWordClass.ExecuteMerge          PROCEDURE(Byte ShowErrors,BYTE SupressBlankLines)
  CODE
    SELF.SetProperty('ActiveDocument.MailMerge.SuppressBlankLines',SupressBlankLines)
    SELF.SendCommand('ActiveDocument.MailMerge.Execute('&ShowErrors&')')
    RETURN True

!==============================================================================
MSWordClass.GetAlignment          PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.ParagraphFormat.Alignment')

!==============================================================================
MSWordClass.GetDocumentsCount     PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Documents.Count')

!==============================================================================
MSWordClass.GetDocumentView     PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveWindow.ActivePane.View.Type')

!==============================================================================
MSWordClass.GetEmailAddressField  PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveDocument.MailMerge.MailAddressFieldName')

!==============================================================================
MSWordClass.GetEmailSubject      PROCEDURE()
  CODE
    RETURN SELF.GetProperty('ActiveDocument.MailMerge.MailSubject')

!==============================================================================
MSWordClass.GetMergeSource          PROCEDURE()
CODE
    RETURN SELF.GetProperty('ActiveDocument.MailMerge.DataSource.Name')

!==============================================================================
MSWordClass.GetMergeType          PROCEDURE()
CODE
    RETURN SELF.GetProperty('ActiveDocument.MailMerge.MainDocumentType')

!==============================================================================
MSWordClass.GetDefaultPaths       PROCEDURE(BYTE Option)
CODE
    RETURN SELF.GetProperty('Options.DefaultFilePath('& CLIP(Option) &')')
    
!==============================================================================
MSWordClass.GetDocumentName       PROCEDURE()
CODE
    RETURN SELF.GetProperty('Documents.Items(1).Name')

!==============================================================================
MSWordClass.GoBottom              PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.EndKey(' & wdStory & ')')

!==============================================================================
MSWordClass.GoTop                 PROCEDURE()
  CODE
    RETURN SELF.GetProperty('Selection.HomeKey(' & wdStory & ')')

!==============================================================================
MSWordClass.InsertImage           PROCEDURE(STRING FileName,BYTE LinkToFile=0,BYTE SaveWithDocument=0)
  CODE
    SELF.SendCommand('Selection.InLineShapes.AddPicture(' & CLIP(FileName) & ','& LinkToFile &','& SaveWithDocument &')')

!==============================================================================
MSWordClass.NewPage               PROCEDURE()
  CODE
    SELF.SendCommand('Selection.InsertBreak(' & wdPageBreak & ')')

!==============================================================================
MSWordClass.OpenDoc               PROCEDURE(STRING FileName,BYTE pReadOnly=False)
  CODE
    SELF.SendCommand('Documents.Open("' & FileName & '",0,' & pReadOnly & ')')

!==============================================================================
MSWordClass.OpenDoc               PROCEDURE(STRING FileName,STRING Password,BYTE pReadOnly=False)
  CODE
    SELF.SendCommand('Documents.Open("' & FileName & '",0,' & pReadOnly & ',0,"' & Password & '")')

!==============================================================================
MSWordClass.PageSetup             PROCEDURE(BYTE PaperSize,BYTE Orientation)
  CODE
    SELF.SetProperty('ActiveDocument.PageSetup.PaperSize',PaperSize)
    SELF.SetProperty('ActiveDocument.PageSetup.Orientation',Orientation)

!==============================================================================
MSWordClass.PrintDoc              PROCEDURE(BYTE pCopies,BYTE pBackgroundPrint=0)
  CODE
    SELF.SendCommand('Application.ActiveDocument.PrintOut(' & pBackgroundPrint & ',0,0,,,,,' & pCopies & ',,,0,1,,)')

!==============================================================================
MSWordClass.PrintDoc              PROCEDURE(BYTE pCopies,BYTE pBackgroundPrint,<BYTE pAppend>,<BYTE pRange>,<STRING pOutputFileName>,<LONG pFrom>,<LONG pTo>,<BYTE pItem>,<STRING pPages>,<BYTE pPageType>,<BYTE pPrintToFile>,<BYTE pCollate>)
  CODE
    SELF.SendCommand('Application.ActiveDocument.PrintOut('& pBackgroundPrint &','& pAppend &','& pRange &','& pOutputFileName &','& pFrom &','& pTo &','& pItem &','& pCopies &','& CLIP(pPages) &','& pPageType  &','& pPrintToFile &','& pCollate &')')

!==============================================================================
MSWordClass.ReadText              PROCEDURE(LONG pStart,LONG pEnd)
  CODE
    IF pStart AND pEnd
      RETURN SELF.Window $ SELF.Control{SELF.GetProperty('ActiveDocument.Range('& pStart &','& pEnd &')')&'.Text'}    
    ELSE
      RETURN SELF.Window $ SELF.Control{SELF.GetProperty('ActiveDocument.Range')&'.Text'}
    END

!==============================================================================
MSWordClass.Replace               PROCEDURE(STRING Search,STRING Replace,BYTE Bookmark,BYTE W_Where)
  CODE
    IF Bookmark
      IF W_Where = 1
        SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',9)
      ELSIF W_Where = 2
        SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',10)
      END!IF
      SELF.SendCommand('Selection.GoTo(,,,"' & Search & '")')
      SELF.SendCommand('WordBasic.Insert("' & QuoteOT(Replace) & '")')
      SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',0)
      SELF.SendCommand('Selection.GoTo(,,,"' & Search & '")')
      SELF.SendCommand('WordBasic.Insert("' & QuoteOT(Replace) & '")')
      SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',0)
    ELSE
      IF W_Where = 1
        SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',9)
      ELSIF W_Where = 2
        SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',10)
      END!IF
      SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',0)
      R# = SELF.GetProperty('ActiveDocument.Content.Find.Execute("' & Search & '",0,0,0,0,0,1,1,0,"' & Replace & '",2)')
      IF R#
        RETURN True
      ELSE
        RETURN False
      END    
    END!IF

!==============================================================================
MSWordClass.Save                  PROCEDURE()
  CODE
    SELF.SendCommand('Application.ActiveDocument.Save')

!==============================================================================
MSWordClass.Save                  PROCEDURE(STRING FileName)
  CODE
    SELF.Save(FileName,0,'""','""',0)

!==============================================================================
MSWordClass.Save                  PROCEDURE(STRING FileName, STRING Password)
  CODE
    SELF.Save(FileName,0,'"' & Password &  '"','""',0)

!==============================================================================
MSWordClass.Save                  PROCEDURE(STRING FileName,BYTE Format,STRING Password,<STRING WritePassword>,<BYTE RecommendReadOnly>)
  CODE
    SELF.SendCommand('Application.ActiveDocument.SaveAs("' & FileName & '",' & Format & ',0,' & Password & ',1,' & WritePassword & ',' & RecommendReadOnly & ',0)')

!==============================================================================
MSWordClass.SendText              PROCEDURE(STRING Text)
  CODE
    SELF.SendCommand('Selection.TypeText("' & QuoteOT(Text) & '")')

!==============================================================================
MSWordClass.Search                PROCEDURE(STRING SearchString,BYTE WrapAction=1,BYTE SearchForward=1,BYTE BeginAtTop=0,BYTE MatchCase=0,BYTE MatchWholeWord=0,BYTE MatchWildcards=0,BYTE MatchSoundsLike=0,BYTE MatchAllWordForms=0)
  CODE
    IF BeginAtTop
       SELF.SendCommand('Selection.HomeKey(6)')
    END
    SELF.SendCommand('Selection.Find.ClearFormatting')
    SELF.SetProperty('Selection.Find.Text',SearchString)
    SELF.SetProperty('Selection.Find.Forward',SearchForward)
    SELF.SetProperty('Selection.Find.Wrap',WrapAction)
    SELF.SetProperty('Selection.Find.Format',False)
    SELF.SetProperty('Selection.Find.MatchCase',MatchCase)
    SELF.SetProperty('Selection.Find.MatchWholeWord',MatchWholeWord)
    SELF.SetProperty('Selection.Find.MatchWildcards',MatchWildcards)
    SELF.SetProperty('Selection.Find.MatchSoundsLike',MatchSoundsLike)
    SELF.SetProperty('Selection.Find.MatchAllWordForms',MatchAllWordForms)
    R# = SELF.GetProperty('Selection.Find.Execute')
    IF R#
       RETURN True
    ELSE
       RETURN False
    END

!==============================================================================
MSWordClass.SetActiveDocument     PROCEDURE(LONG IndexDocument)
  CODE
    SELF.SendCommand('Documents('&IndexDocument&').Activate')

!==============================================================================
MSWordClass.SetAlignment          PROCEDURE(BYTE Justification)
  CODE
    SELF.SetProperty('Selection.ParagraphFormat.Alignment',Justification)

!==============================================================================
MSWordClass.SetDocumentView     PROCEDURE(BYTE DocumentView)
  CODE
    SELF.setProperty('ActiveWindow.ActivePane.View.Type',DocumentView)


!==============================================================================
MSWordClass.SetEmailAddressField  PROCEDURE(STRING AddressField)
  CODE
    SELF.SetProperty('ActiveDocument.MailMerge.MailAddressFieldName',AddressField)

!==============================================================================
MSWordClass.SetEmailSubject  PROCEDURE(STRING MailSubject)
  CODE
    SELF.SetProperty('ActiveDocument.MailMerge.MailSubject',MailSubject)

!==============================================================================
MSWordClass.SetFooter             PROCEDURE(STRING Text,BYTE Justification,STRING FontName,SHORT FontSize,BYTE Bold,BYTE Italic,LONG FontColor)
  CODE
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',10)
    IF FontName
      SELF.SetFont(FontName)
    END!IF
    IF FontSize
      SELF.SetFontSize(FontSize)
    END!IF
    SELF.SetBold(Bold)
    SELF.SetItalic(Italic)
    SELF.SetFontColor(FontColor)
    IF Justification
      SELF.SetAlignment(Justification)
    END!IF
    SELF.SendText(QuoteOT(Text))
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',0)

!==============================================================================
MSWordClass.SetFontColor          PROCEDURE(LONG FontColor)
pColor  LONG
   CODE
    CASE(FontColor)
    OF COLOR:Black
      pColor = wdBlack
    OF COLOR:Maroon
      pColor = wdDarkRed
    OF COLOR:Green
      pColor = wdGreen
    OF COLOR:Olive
      pColor = wdBrightGreen
    OF COLOR:Navy
      pColor = wdDarkBlue
    OF COLOR:Purple
      pColor = wdViolet
    OF COLOR:Teal
      pColor = wdTeal
    OF COLOR:Gray
      pColor = wdGray25
    OF COLOR:Silver
      pColor = wdGray50
    OF COLOR:Red
      pColor = wdRed
    OF COLOR:Lime
      pColor = wdDarkYellow
    OF COLOR:Yellow
      pColor = wdYellow
    OF COLOR:Blue
      pColor = wdBlue
    OF COLOR:Fuschia
      pColor = wdPink
    OF COLOR:Aqua
      pColor = wdTurquoise
    OF COLOR:White
      pColor = wdWhite
    ELSE
      pColor = wdAuto
    END
    IF SELF.GetVersion() < 9
       SELF.SetProperty('Selection.Font.ColorIndex',pColor)
    ELSE

       SELF.SetProperty('Selection.Font.Color',FontColor)
    END
    
!==============================================================================
MSWordClass.SetHeader             PROCEDURE(STRING Text,BYTE Justification,STRING FontName,SHORT FontSize,BYTE Bold,BYTE Italic,LONG FontColor)
  CODE
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',9)
    IF FontName
      SELF.SetFont(FontName)
    END!IF
    IF FontSize
      SELF.SetFontSize(FontSize)
    END!IF
    SELF.SetBold(Bold)
    SELF.SetItalic(Italic)
    SELF.SetFontColor(FontColor)
    IF Justification
      SELF.SetAlignment(Justification)
    END!IF
    SELF.SendText(QuoteOT(Text))
    SELF.SetProperty('ActiveWindow.ActivePane.View.SeekView',0)

!==============================================================================
MSWordClass.SetMargins            PROCEDURE(SHORT Top,SHORT Bottom,SHORT Left,SHORT Right)
  CODE
    SELF.SetProperty('ActiveDocument.PageSetup.TopMargin',Top)
    SELF.SetProperty('ActiveDocument.PageSetup.BottomMargin',Bottom)
    SELF.SetProperty('ActiveDocument.PageSetup.LeftMargin',Left)
    SELF.SetProperty('ActiveDocument.PageSetup.RightMargin',Right)

!==============================================================================
MSWordClass.SetMergeOptions       PROCEDURE(BYTE Destination,BYTE SupressBlankLines=True)
MergeD  CSTRING(20)
CODE
    SELF.SetProperty('ActiveDocument.MailMerge.Destination',Destination)
    SELF.SetProperty('ActiveDocument.MailMerge.SupressBlankLines',SupressBlankLines)

!==============================================================================
MSWordClass.SetMergeRecords       PROCEDURE(LONG pFrom=wdDefaultFirstRecord,LONG pTo=wdDefaultLastRecord)
MergeD  CSTRING(20)
CODE
    SELF.SetProperty('ActiveDocument.MailMerge.DataSource.FirstRecord',pFrom)
    SELF.SetProperty('ActiveDocument.MailMerge.DataSource.LastRecord',pTo)

!==============================================================================
MSWordClass.SetMergeSource        PROCEDURE(STRING SourceFile)
p1  CSTRING(256)
p2  CSTRING(256)
p3  CSTRING(256)
p4  CSTRING(256)
p5  CSTRING(256)
CODE
    p5 = CLIP(SourceFile)
    R# = FnSplit(p5,p1,p2,p3,p4)
    IF SELF.GetVersion() > 8
       SELF.SendCommand('ActiveDocument.MailMerge.OpenDataSource('& CLIP(SourceFile) &')')
    ELSE
       SELF.SendCommand('ActiveDocument.MailMerge.OpenDataSource("' & CLIP(SourceFile) &'", 0, False, False, True, False, , , , , , "", "SELECT * FROM '&p3&'", "")')
    END

!==============================================================================
MSWordClass.SetMergeType          PROCEDURE(BYTE MergeType)
CODE
    SELF.SetProperty('ActiveDocument.MailMerge.MainDocumentType',MergeType)

!==============================================================================
MSWordClass.SetDefaultPaths       PROCEDURE(BYTE Option,STRING OptionValue)
CODE
    SELF.SetProperty('Options.DefaultFilePath('& CLIP(Option) &')',CLIP(OptionValue))

!==============================================================================
MSWordClass.Start                 PROCEDURE()
  CODE
    SELF.Window $ SELF.Control{PROP:Create} = 'Word.Application'
    PARENT.Start()

!==============================================================================
QuoteOT                             PROCEDURE(STRING Text)
TmpStr  CSTRING(256)
Pos     BYTE
Start   BYTE
  CODE
    TmpStr = Text
    Start  = 1
    LOOP
      Pos = INSTRING('"',TmpStr,1,Start)
      IF NOT Pos THEN BREAK.
      TmpStr = TmpStr[1 : Pos - 1] & '""' & TmpStr[Pos + 1 : LEN(TmpStr)]
      Start = Pos + 2
    END!LOOP
    RETURN TmpStr

!==============================================================================
